<?php
namespace Teknisa\FAI\Modules\Tabelas\Controllers;

use Zeedhi\Framework\DTO\Response\Error;

 class Fai24000TipoDeOperacaoPorContratoDeFaturamento extends \Teknisa\GER\Controllers\TeknisaCrud{
	protected $dataSourceName = '';
	protected $parameterBagColumns = array();
	protected $connection;
	protected $crudService;
	protected $parameterBag;

	public function __construct($crudService, $parameterBag, $connection){
		$this->crudService  = $crudService;
		$this->parameterBag = $parameterBag;
		$this->connection 	= $connection;

		parent::__construct($crudService, $parameterBag);
	}

	public function findTipooperac($request, $response){
		$this->dataSourceName = 'fai24000_tipooperac';
		$this->parameterBagColumns = array('CDTIPOFATUR');
		parent::find($request, $response);
	}

	public function saveTipooperac($request, $response){
		$rows = $request->getDataSet()->getRows();
		
		foreach($rows as $row){
			$this->update($row->get("DSTIPOOPEFAT"), $row->get("CDTIPOOPER"));
		}
		
	}

	public function update($tipoopfat, $cdtipooper){
		$sql = "UPDATE TIPOOPERAC
						SET
						  DSTIPOOPEFAT = :DSTIPOOPEFAT
						WHERE
						  CDTIPOOPER = :CDTIPOOPER";
		$params = array(
			'CDTIPOOPER' => $cdtipooper,
			'DSTIPOOPEFAT' => $tipoopfat
		);

		$query = $this->connection->prepare($sql);
    $query->execute($params);
	}

	public function deleteTipooperac($request, $response){
		$rows = $request->getDataSet()->getRows();
		//var_dump($rows);
		
		 foreach ($rows as $row){
			$dsTipoOpeFat = explode("_", $row->get("DSTIPOOPEFAT"));
			$indexOfCdTipoFatur = array_search($row->get("CDTIPOFATUR"), $dsTipoOpeFat);
			
			array_splice($dsTipoOpeFat, $indexOfCdTipoFatur, 1);
			
			$dsTipoOpeFat = implode("_", $dsTipoOpeFat);
			
			// $this->update($row['DSTIPOOPEFAT'], $row['CDTIPOOPER']);
		 	$this->update($dsTipoOpeFat, $row->get("CDTIPOOPER"));
		 }
	}
	

}